<script lang="ts">
	import { createEventDispatcher } from "svelte"
	import * as EmailValidator from "email-validator"
	import FileInput from "./FileInput.svelte"

	export let comment: string | null = null
	export let email: string | null = null
	export let filteredFiles: Array<string> = []
	export let isAnonymous: boolean = false

	export let previousFiles: Array<string> | null = null
	export let removedFiles: Array<string> | null = null
	let uploadedFiles: Array<string> = []

	let emailIsValid = false

	const dispatch = createEventDispatcher<{ submit: FormData }>()

	function updateComment(event) {
		comment = event.target.value
		if (comment.length === 0) {
			comment = null
		}
	}

	function updateEmail(event) {
		email = event.target.value
		if (email.length === 0) {
			email = null
		}
		emailIsValid = EmailValidator.validate(email)
	}

	function handleSubmit(event) {
		const formData = new FormData(event.target)
		dispatch("submit", formData)
	}

	let submitDisabled = true
	$: submitDisabled =
		!(comment !== null && filteredFiles.length > 0 && (emailIsValid || !isAnonymous)) ||
		(uploadedFiles.length === 0 && removedFiles.length === 0)
</script>

<form class="w-full md:w-4/12 py-10 space-y-4 mb-8" on:submit|preventDefault={handleSubmit}>
	<div class="card">
		<div class="card-header">Leave a comment to describe your proposal *</div>
		<div class="card-body">
			<label class="form-input" for="contribution-comment">
				<input type="text" class="w-full" name="contribution-comment" value={comment} on:input={updateComment} />
			</label>
		</div>
	</div>

	<div class="card">
		<div class="card-header">Resources *</div>
		<div class="card-body">
			<FileInput bind:filteredFiles {previousFiles} bind:removedFiles bind:uploadedFiles />
		</div>
	</div>

	{#if isAnonymous}
		<div class="card">
			<div class="card-header">email *</div>
			<div class="card-body">
				<label class="form-input" for="contribution-email">
					<input type="email" class="w-full" name="contribution-email" value={email} on:input={updateEmail} />
				</label>
			</div>
		</div>
	{/if}

	<input
		type="submit"
		disabled={submitDisabled}
		class="btn btn-primary w-64 mt-4 float-right"
		value="Submit Data Package Contribution"
	/>
</form>

<style>
	input {
		outline: none;
	}
</style>
